package com.icloud.server.user;


import org.apache.commons.codec.binary.Base64;

import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;

/**
 * @author Administrator
 */
public class AESUtil {

    // 加密
    public static String Encrypt(String sSrc, String sKey) throws Exception {
        if (sKey == null) {
            System.out.println("Key为空null");
            return null;
        }
        // 判断Key是否为16位
        if (sKey.length() != 16) {
//            System.out.println("Key长度不是16位");
            return null;
        }
        byte[] raw = sKey.getBytes("utf-8");
        SecretKeySpec skeySpec = new SecretKeySpec(raw, "AES");
        Cipher cipher = Cipher.getInstance("AES/ECB/PKCS5Padding");//"算法/模式/补码方式"
        cipher.init(Cipher.ENCRYPT_MODE, skeySpec);
        byte[] encrypted = cipher.doFinal(sSrc.getBytes("utf-8"));

        return new Base64().encodeToString(encrypted);//此处使用BASE64做转码功能，同时能起到2次加密的作用。
    }

    // 解密
    public static String Decrypt(String sSrc, String sKey) throws Exception {
        try {
            // 判断Key是否正确
            if (sKey == null) {
                System.out.println("Key为空null");
                return null;
            }
            // 判断Key是否为16位
            if (sKey.length() != 16) {
//                System.out.println("Key长度不是16位");
                return null;
            }
            byte[] raw = sKey.getBytes("utf-8");

            SecretKeySpec skeySpec = new SecretKeySpec(raw, "AES");
            Cipher cipher = Cipher.getInstance("AES/ECB/PKCS5Padding");
            cipher.init(Cipher.DECRYPT_MODE, skeySpec);
            byte[] encrypted1 = new Base64().decode(sSrc);//先用base64解密
            try {
                byte[] original = cipher.doFinal(encrypted1);
                String originalString = new String(original, "utf-8");
                return originalString;
            } catch (Exception e) {
                System.out.println(e.toString());
                return null;
            }
        } catch (Exception ex) {
            System.out.println(ex.toString());
            return null;
        }
    }

    public static void main(String[] args) throws Exception {
        /*
         * 此处使用AES-128-ECB加密模式，key需要为16位。
         */
        String cKey = "ocschool20200824";

        System.out.println(cKey);
        // 需要加密的字串
        //欧畅云账户的密码测试账户的密码
        String cSrc = "AmIozjGMKNQaoG1U";
        //String cSrc = "654321";
        System.out.println(cSrc);
        // 加密
        String enString = AESUtil.Encrypt(cSrc, cKey);
        System.out.println("加密后的字串是：" + enString);
        //String mm = "ga4JaZdcU0MsUmYLza5MeQ";
        // 解密
        //String DeString = AESUtil.Decrypt(mm, cKey);
        //String DeString = AESUtil.Decrypt("2H5jyO5+zJcwNGZhtWAT8Q==", cKey);
        String DeString = AESUtil.Decrypt("b/cMNm2agJxIRWb3HeoCSqCE2+s58C0IbG5n6jxR00M=", cKey);
        System.out.println("解密后的字串是：" + DeString);
    }
}