package com.icloud.server.web.shiro.handler;

import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * @description:
 * @author: zjbing
 * @create: 2021-01-13 13:29
 **/
@Data
public class UserToken implements Serializable {

    private static final long serialVersionUID = 8798594496773855969L;
    // token id
    private String id;
    // 用户id
    private Long userId;

    /**
     * 用户名
     */
    private String username;

    /**
     * 手机号
     */
    private String phone;

    /**
     * 所属客户ID
     */
    private Long clientId;

    /**
     * 员工所属部门
     */
    private Integer department;

    /**
     * 禁用标识 0启用 1锁定
     */
    //private Boolean lockFlag;

    /**
     * 注册类型 1手机号 2微信 3QQ
     */
    private Short registrationType;

    // ip
    private String ip;
    // 客户端
    private String userAgent;
    // 授权时间
    private LocalDateTime issuedAt;
    // 过期时间
    private LocalDateTime expiresAt;
    // 是否记住我
    private boolean remember;

}
